; 

    .486                       ; create 32 bit code
    .model flat, stdcall       ; 32 bit memory model
    option casemap :none       ; case sensitive
 
    include \masm32\include\windows.inc
    include \masm32\include\masm32.inc
    include \masm32\include\gdi32.inc
    include \masm32\include\user32.inc
    include \masm32\include\kernel32.inc
    include \masm32\include\Comctl32.inc
    include \masm32\include\comdlg32.inc
    include \masm32\include\shell32.inc
    include \masm32\include\oleaut32.inc
    include \masm32\macros\macros.asm

    includelib \masm32\lib\masm32.lib
    includelib \masm32\lib\gdi32.lib
    includelib \masm32\lib\user32.lib
    includelib \masm32\lib\kernel32.lib
    includelib \masm32\lib\Comctl32.lib
    includelib \masm32\lib\comdlg32.lib
    includelib \masm32\lib\shell32.lib
    includelib \masm32\lib\oleaut32.lib

    OpenDialog PROTO :DWORD,:DWORD,:DWORD,:DWORD
    DlgHook    PROTO :DWORD,:DWORD,:DWORD,:DWORD

; 

    .data?
      openfilebuffer db 260 dup (?)

    .data
      pattn db "All Files",0,"*.*",0,0

    .code

start:
 
; 

main proc

    LOCAL fname :DWORD
    LOCAL hInstance :DWORD

    invoke GetModuleHandle,NULL
    mov hInstance, eax

    fn OpenDialog,0,hInstance,"Run File ...",ADDR pattn
    mov fname, eax

    cmp BYTE PTR [eax], 0
    je nofileselected

    fn ShellExecute,NULL,"open",fname,NULL,NULL,SW_SHOWNORMAL

  nofileselected:

    exit

main endp

; 

align 4

OpenDialog proc hParent:DWORD,Instance:DWORD,lpTitle:DWORD,lpFilter:DWORD

    LOCAL ofn:OPENFILENAME

    mov eax, OFFSET openfilebuffer
    mov BYTE PTR [eax], 0

  ; --------------------
  ; zero fill structure
  ; --------------------
    push edi
    mov ecx, sizeof OPENFILENAME
    mov al, 0
    lea edi, ofn
    rep stosb
    pop edi

    mov ofn.lStructSize,    sizeof OPENFILENAME
    m2m ofn.hWndOwner,      hParent
    m2m ofn.hInstance,      Instance
    m2m ofn.lpstrFilter,    lpFilter
    m2m ofn.lpstrFile,      offset openfilebuffer
    mov ofn.nMaxFile,       sizeof openfilebuffer
    m2m ofn.lpstrTitle,     lpTitle
    mov ofn.Flags,          OFN_EXPLORER or OFN_FILEMUSTEXIST or \
                            OFN_LONGNAMES or OFN_HIDEREADONLY or OFN_ENABLEHOOK or 00800000h; OFN_ENABLESIZING

  ; -----------------------------------------------------------
  ; set a hook to the dialog proc so you can work on the dialog.
  ; -----------------------------------------------------------
    mov eax, OFFSET DlgHook
    mov ofn.lpfnHook, eax             

    mov eax, CurDir$()      ; start in current directory
    mov ofn.lpstrInitialDir, eax

    invoke GetOpenFileName,ADDR ofn
    mov eax, OFFSET openfilebuffer
    ret

OpenDialog endp

; 

DlgHook proc hChild:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD

    LOCAL hParent   :DWORD
    LOCAL styl      :DWORD
    LOCAL sWid      :DWORD
    LOCAL sHgt      :DWORD
    LOCAL wWid      :DWORD
    LOCAL wHgt      :DWORD
    LOCAL rct       :RECT

    .if uMsg == WM_INITDIALOG

    ; ----------------------------------------------------------------
    ; The parent handle is the handle of the file open dialog.
    ; The following code starts the dialog in the middle of the screen.
    ; ----------------------------------------------------------------

      mov hParent, FUNC(GetParent,hChild)

      invoke GetWindowRect,hParent,ADDR rct
      mov ecx, rct.right
      sub ecx, rct.left
      mov edx, rct.bottom
      sub edx, rct.top
      mov wWid, ecx
      mov wHgt, edx

      mov sWid, FUNC(GetSystemMetrics,SM_CXSCREEN)
      mov sHgt, FUNC(GetSystemMetrics,SM_CYSCREEN)

      shr sWid, 1
      shr sHgt, 1
      shr wWid, 1
      shr wHgt, 1

      mov ecx, wWid
      sub sWid, ecx
      mov edx, wHgt
      sub sHgt, edx

      shl wWid, 1
      shl wHgt, 1

      invoke MoveWindow,hParent,sWid,sHgt,wWid,wHgt,TRUE
    .endif

    mov eax, 0

    ret

DlgHook endp

; 

end start
